<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
<meta http-equiv="content-type" content="text/html; charset=ISO-8859-1" /><title>CookiePathComparator xref</title>
<link type="text/css" rel="stylesheet" href="../../../../../stylesheet.css" />
</head>
<body>
<div id="overview"><a href="../../../../../../apidocs/org/apache/commons/httpclient/cookie/CookiePathComparator.html">View Javadoc</a></div><pre>

<a name="1" href="#1">1</a>   <em class="comment">/*</em>
<a name="2" href="#2">2</a>   <em class="comment"> * $HeadURL: https://svn.apache.org/repos/asf/httpcomponents/oac.hc3x/trunk/src/java/org/apache/commons/httpclient/cookie/CookiePathComparator.java $</em>
<a name="3" href="#3">3</a>   <em class="comment"> * $Revision:400312 $</em>
<a name="4" href="#4">4</a>   <em class="comment"> * $Date:2006-05-06 14:49:41 +0200 (Sat, 06 May 2006) $</em>
<a name="5" href="#5">5</a>   <em class="comment"> *</em>
<a name="6" href="#6">6</a>   <em class="comment"> * ====================================================================</em>
<a name="7" href="#7">7</a>   <em class="comment"> *</em>
<a name="8" href="#8">8</a>   <em class="comment"> *  Licensed to the Apache Software Foundation (ASF) under one or more</em>
<a name="9" href="#9">9</a>   <em class="comment"> *  contributor license agreements.  See the NOTICE file distributed with</em>
<a name="10" href="#10">10</a>  <em class="comment"> *  this work for additional information regarding copyright ownership.</em>
<a name="11" href="#11">11</a>  <em class="comment"> *  The ASF licenses this file to You under the Apache License, Version 2.0</em>
<a name="12" href="#12">12</a>  <em class="comment"> *  (the "License"); you may not use this file except in compliance with</em>
<a name="13" href="#13">13</a>  <em class="comment"> *  the License.  You may obtain a copy of the License at</em>
<a name="14" href="#14">14</a>  <em class="comment"> *</em>
<a name="15" href="#15">15</a>  <em class="comment"> *      <a href="http://www.apache.org/licenses/LICENSE-2.0" target="alexandria_uri">http://www.apache.org/licenses/LICENSE-2.0</a></em>
<a name="16" href="#16">16</a>  <em class="comment"> *</em>
<a name="17" href="#17">17</a>  <em class="comment"> *  Unless required by applicable law or agreed to in writing, software</em>
<a name="18" href="#18">18</a>  <em class="comment"> *  distributed under the License is distributed on an "AS IS" BASIS,</em>
<a name="19" href="#19">19</a>  <em class="comment"> *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.</em>
<a name="20" href="#20">20</a>  <em class="comment"> *  See the License for the specific language governing permissions and</em>
<a name="21" href="#21">21</a>  <em class="comment"> *  limitations under the License.</em>
<a name="22" href="#22">22</a>  <em class="comment"> * ====================================================================</em>
<a name="23" href="#23">23</a>  <em class="comment"> *</em>
<a name="24" href="#24">24</a>  <em class="comment"> * This software consists of voluntary contributions made by many</em>
<a name="25" href="#25">25</a>  <em class="comment"> * individuals on behalf of the Apache Software Foundation.  For more</em>
<a name="26" href="#26">26</a>  <em class="comment"> * information on the Apache Software Foundation, please see</em>
<a name="27" href="#27">27</a>  <em class="comment"> * &lt;<a href="http://www.apache.org/" target="alexandria_uri">http://www.apache.org/</a>>.</em>
<a name="28" href="#28">28</a>  <em class="comment"> *</em>
<a name="29" href="#29">29</a>  <em class="comment"> */</em>
<a name="30" href="#30">30</a>  
<a name="31" href="#31">31</a>  <strong>package</strong> <a href="../../../../../org/apache/commons/httpclient/cookie/package-summary.html">org.apache.commons.httpclient.cookie</a>;
<a name="32" href="#32">32</a>  
<a name="33" href="#33">33</a>  <strong>import</strong> java.util.Comparator;
<a name="34" href="#34">34</a>  
<a name="35" href="#35">35</a>  <strong>import</strong> org.apache.commons.httpclient.Cookie;
<a name="36" href="#36">36</a>  
<a name="37" href="#37">37</a>  <em>/**<em>*</em></em>
<a name="38" href="#38">38</a>  <em> * This cookie comparator ensures that multiple cookies satisfying </em>
<a name="39" href="#39">39</a>  <em> * a common criteria are ordered in the &lt;tt>Cookie&lt;/tt> header such</em>
<a name="40" href="#40">40</a>  <em> * that those with more specific Path attributes precede those with</em>
<a name="41" href="#41">41</a>  <em> * less specific.</em>
<a name="42" href="#42">42</a>  <em> *  </em>
<a name="43" href="#43">43</a>  <em> * &lt;p></em>
<a name="44" href="#44">44</a>  <em> * This comparator assumes that Path attributes of two cookies </em>
<a name="45" href="#45">45</a>  <em> * path-match a commmon request-URI. Otherwise, the result of the</em>
<a name="46" href="#46">46</a>  <em> * comparison is undefined.</em>
<a name="47" href="#47">47</a>  <em> * &lt;/p></em>
<a name="48" href="#48">48</a>  <em> * </em>
<a name="49" href="#49">49</a>  <em> * @author &lt;a href="<a href="mailto:oleg" target="alexandria_uri">mailto:oleg</a> at ural.ru">Oleg Kalnichevski&lt;/a></em>
<a name="50" href="#50">50</a>  <em> * </em>
<a name="51" href="#51">51</a>  <em> * @since 3.1</em>
<a name="52" href="#52">52</a>  <em> */</em>
<a name="53" href="#53">53</a>  <strong>public</strong> <strong>class</strong> <a href="../../../../../org/apache/commons/httpclient/cookie/CookiePathComparator.html">CookiePathComparator</a> implements Comparator {
<a name="54" href="#54">54</a>  
<a name="55" href="#55">55</a>      <strong>private</strong> String normalizePath(<strong>final</strong> <a href="../../../../../org/apache/commons/httpclient/Cookie.html">Cookie</a> cookie) {
<a name="56" href="#56">56</a>          String path = cookie.getPath();
<a name="57" href="#57">57</a>          <strong>if</strong> (path == <strong>null</strong>) {
<a name="58" href="#58">58</a>              path = <span class="string">"/"</span>;
<a name="59" href="#59">59</a>          }
<a name="60" href="#60">60</a>          <strong>if</strong> (!path.endsWith(<span class="string">"/"</span>)) {
<a name="61" href="#61">61</a>              path = path + <span class="string">"/"</span>;
<a name="62" href="#62">62</a>          }
<a name="63" href="#63">63</a>          <strong>return</strong> path;
<a name="64" href="#64">64</a>      }
<a name="65" href="#65">65</a>      
<a name="66" href="#66">66</a>      <strong>public</strong> <strong>int</strong> compare(<strong>final</strong> Object o1, <strong>final</strong> Object o2) {
<a name="67" href="#67">67</a>          <a href="../../../../../org/apache/commons/httpclient/Cookie.html">Cookie</a> c1 = (Cookie) o1;
<a name="68" href="#68">68</a>          <a href="../../../../../org/apache/commons/httpclient/Cookie.html">Cookie</a> c2 = (Cookie) o2;
<a name="69" href="#69">69</a>          String path1 = normalizePath(c1);
<a name="70" href="#70">70</a>          String path2 = normalizePath(c2);
<a name="71" href="#71">71</a>          <strong>if</strong> (path1.equals(path2)) {
<a name="72" href="#72">72</a>              <strong>return</strong> 0;
<a name="73" href="#73">73</a>          } <strong>else</strong> <strong>if</strong> (path1.startsWith(path2)) {
<a name="74" href="#74">74</a>              <strong>return</strong> -1;
<a name="75" href="#75">75</a>          } <strong>else</strong> <strong>if</strong> (path2.startsWith(path1)) {
<a name="76" href="#76">76</a>              <strong>return</strong> 1;
<a name="77" href="#77">77</a>          } <strong>else</strong> {
<a name="78" href="#78">78</a>              <em class="comment">// Does not really matter</em>
<a name="79" href="#79">79</a>              <strong>return</strong> 0;
<a name="80" href="#80">80</a>          }
<a name="81" href="#81">81</a>      }
<a name="82" href="#82">82</a>  
<a name="83" href="#83">83</a>  }
</pre>
<hr/><div id="footer">This page was automatically generated by <a href="http://maven.apache.org/">Maven</a></div></body>
</html>

